//
//  {{ prefix }}{{ module_info.name }}{{ module_info.file_name }}
//  {{ module_info.project_name }}
//
//  Created by {{ developer.name }} on {{ date }}.
//  Copyright © {{ year }} {{ developer.company }}. All rights reserved.
//

import UIKit


protocol {{ module_info.name }}ModuleInputProtocol: ModuleInputProtocol {

}

protocol {{ module_info.name }}ModuleOutputProtocol {

}


final class {{ module_info.name }}Module: Module {

    private(set) var view: UIViewController
    private(set) var input: {{ module_info.name }}ModuleInputProtocol

    private init(view: {{ module_info.name }}ViewController, input: {{ module_info.name }}ModuleInputProtocol) {

	self.view = view
	self.input = input
    }

    static func assembly() ->  {{ module_info.name }}Module{

        let router = {{ module_info.name }}Router()
        let presenter = {{ module_info.name }}Presenter()
        let view = {{ module_info.name }}ViewController()
        let interactor = {{ module_info.name }}Interactor()

        view.output = presenter
        presenter.view = view
        presenter.router = router
        presenter.interactor = interactor
        router.transitionHandler = view
	
        let module = {{ module_info.name }}Module(view: view, input: presenter)
        return module

    }

}
